searchNodes=[{"doc":"Generates boilerplate for a new Rustler project. Usage: mix rustler . new [ -- module &lt; Module &gt; ] [ -- name &lt; Name &gt; ] [ -- otp - app &lt; OTP App &gt; ]","ref":"Mix.Tasks.Rustler.New.html","title":"Mix.Tasks.Rustler.New","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Rustler.New.html#run/1","title":"Mix.Tasks.Rustler.New.run/1","type":"function"},{"doc":"Provides compile-time configuration for a NIF module. When used, Rustler expects the :otp_app as option. The :otp_app should point to the OTP application that the dynamic library can be loaded from. For example: defmodule MyNIF do use Rustler , otp_app : :my_nif end This allows the module to be configured like so: config :my_nif , MyNIF , crate : :my_nif , load_data : [ 1 , 2 , 3 ] Configuration options :cargo - Specify how to envoke the rust compiler. Options are: :system (default) - use cargo from the system (must be in $PATH ) {:system, &lt;channel&gt;} - use cargo from the system with the given channel. Specified as a string, passed directly to cargo (e.g. &quot;+nightly&quot;). {:rustup, &lt;version&gt;} - use rustup to specify which channel to use. Available options include: :stable , :beta , :nightly , or a string which specifies a specific version (e.g. &quot;1.39.0&quot; ). {:bin, &quot;/path/to/binary&quot;} - provide a specific path to cargo . :crate - the name of the Rust crate, if different from your otp_app value. If you have more than one crate in your project, you will need to be explicit about which crate you intend to use. :default_features - a boolean to specify whether the crate's default features should be used. :env - Specify a list of environment variables when envoking the compiler. :features - a list of features to enable when compiling the crate. :load_data - Any valid term. This value is passed into the NIF when it is loaded (default: 0 ) :load_data_fun - {Module, :function} to dynamically generate load_data . Default value: nil . This parameter is mutually exclusive with load_data which means that load_data has to be set to it's default value. Example defmodule NIF do use Rustler , load_data_fun : { Deployment , :nif_data } end defmodule Deployment do def nif_data do :code . priv_dir ( :otp_app ) |&gt; IO . iodata_to_binary ( ) end end :load_from - This option allows control over where the final artifact should be loaded from at runtime. By default the compiled artifact is loaded from the owning :otp_app 's priv/native directory. This option comes in handy in combination with the :skip_compilation? option in order to load pre-compiled artifacts. To override the default behaviour specify a tuple: {:my_app, &quot;priv/native/&lt;artifact&gt;&quot;} . Due to the way :erlang.load_nif/2 works, the artifact should not include the file extension (i.e. .so , .dll ). :mode - Specify which mode to compile the crate with (default: :release ) :path - By default, rustler expects the crate to be found in native/&lt;crate&gt; in the root of the project. Use this option to override this. :skip_compilation? - This option skips envoking the rust compiler. Specify this option in combination with :load_from to load a pre-compiled artifact. :target - Specify a compile target triple. :target_dir : Override the compiler output directory. Any of the above options can be passed directly into the use macro like so: defmodule MyNIF do use Rustler , otp_app : :my_nif , crate : :some_other_crate , load_data : :something end","ref":"Rustler.html","title":"Rustler","type":"module"},{"doc":"","ref":"Rustler.html#construct_load_data/2","title":"Rustler.construct_load_data/2","type":"function"},{"doc":"Supported NIF API versions.","ref":"Rustler.html#nif_versions/0","title":"Rustler.nif_versions/0","type":"function"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning . See UPGRADE.md for additional help when upgrading to newer versions.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - [unreleased]","type":"extras"},{"doc":"ErlOption&lt;T&gt; to provide an ergonomic option type for Erlang (#507, thanks @tatsuya6502) Changed Use Cargo features to define the NIF version level (#537), deprecating RUSTLER_NIF_VERSION","ref":"changelog.html#added","title":"Changelog - Added","type":"extras"},{"doc":"Added Support OTP 26 (#526, thanks @philss) Support tuples in NIF macro (#520, #527, thanks @denumerate and @philss) Supportfor load_data_fun to compute load_data at runtime (#413, thanks @kaaboaye) Changed Enhanced NIF macro error messages for invalid attributes (#525, thanks @philss)","ref":"changelog.html#0-28-0-2023-04-24","title":"Changelog - [0.28.0] - 2023-04-24","type":"extras"},{"doc":"BREAKING MIX_ENV is no longer considered for determining the build profile. Now, the profile defaults to :release . Use the :mode option to pick another profile explicitly. (#496) Added ResourceArc::make_binary for safe use of enif_make_resource_binary (#487) OwnedBinary is now Sync (#493) Specified MSRV to be 1.56.1. Fixed Documentation for load (#501, thanks @ishitatsuyuki) Changed Edition 2021 for the rustler mix template (#512, thanks @ayrat555)","ref":"changelog.html#0-27-0-2023-01-17","title":"Changelog - [0.27.0] - 2023-01-17","type":"extras"},{"doc":"Highlight TaggedEnum We added TaggedEnum , which is a generalized enum type (#440, thanks to @SeokminHong!). Example: #[derive(NifTaggedEnum)] pub enum TaggedEnum1 { Named { x: i32, y: i32 }, String1(String), String2(String), Untagged, } On the Elixir side, the variants are represented as two-tuples {tag::atom(), inner::term()} | atom() , where the inner term is a map for the variant Named in the example above a binary for the String1 and String2 variants The Untagged variant is represented as the atom :untagged in Elixir. Added Added Clone and Copy for TermType (#476, thanks @dvic) Added Env.whereis_pid() (#456, thanks @Qqwy) Improved Use &amp;[impl Encoder] for keys and values in map_from_arrays() to improve ergonomics (#453, thanks @SeokminHong) Improved encode/decode performance of TaggedEnum considerably (#482, thanks @cleaton) Test on OTP 25 (#455) Fixed Lifetime handling in rustler_codegen (#483, thanks @turion @SeokminHong and @neosimsim) Support multiple variants with same field names in TaggedEnum (#482, thanks @cleaton) Support .toml file extension for cargo config (#468, thanks @joshuataylor for the report in #467) Disambiguate encode / decode in generated code (#466, thanks @SeokminHong) Migrate CI to erlef/setup-beam (#457, thanks @SeokminHong) Documentation of the schedule flag for nif macro (#444) Improve documentation (#429, thanks @turion)","ref":"changelog.html#0-26-0-2022-09-02","title":"Changelog - [0.26.0] - 2022-09-02","type":"extras"},{"doc":"Added NewBinary now also available as rustler::NewBinary (thanks @ayrat555) Term::map_from_pairs() to conveniently build a map from a list -of pairs (thanks @philss) CI now also tests against macos Fixed Snake-case warening for auto-generated RUSTLER_{}_field_{} variables (renamed to rustler_{}_field_{} ) Changed Abort compilation on macos if macos target configuration is missing","ref":"changelog.html#0-25-0-2022-04-11","title":"Changelog - [0.25.0] - 2022-04-11","type":"extras"},{"doc":"Added A NewBinary type to create binaries in Rust without going through OwnedBinary . This can improve performance. Thanks @dlesl! TermType derives Eq and PartialEq . Updated rustler_mix : Bumped required toml dependency to 0.6 Bumped rustler_sys dependency to ~2.2 . Changed Rustler supports the latest 3 versions of Elixir and OTP. Currently, those are Elixir =&gt; 1.11 and OTP &gt;= 22. Fixed Set library file extension based on the compile target, thanks @cocoa-xu! Relaxed Jason version requirement to ~&gt; 1.0 Various typos in the documentation, thanks @kianmeng!","ref":"changelog.html#0-24-0-2022-02-24","title":"Changelog - [0.24.0] - 2022-02-24","type":"extras"},{"doc":"Added NifException for using Elixir exception structs Hashing for term Hash and Equality for Binary and OwnedBinary Changed Rustler changed its supported range of OTP and Elixir versions. We aim to support the three newest versions of OTP and Elixir. The decoder for Range requires that :step equals 1 . The :step field was introduced with Elixir v1.12 and cannot be represented with Rust's RangeInclusive . NIF API bindings are generated using Rust","ref":"changelog.html#0-23-0-2021-12-22","title":"Changelog - [0.23.0] - 2021-12-22","type":"extras"},{"doc":"mix rustler.new with Elixir v1.13 Template config for macos Crash if metadata cannot be retrieved while compiling (#398)","ref":"changelog.html#fixed","title":"Changelog - Fixed","type":"extras"},{"doc":"Fixed Fixed a regression introduced with #386: Rustler.Compiler.Config called into cargo when skip_compilation? was set, breaking setups where cargo is not installed. Fixed with #389, thanks @karolsluszniak","ref":"changelog.html#0-22-2-2021-10-07","title":"Changelog - [0.22.2] - 2021-10-07","type":"extras"},{"doc":"Fixed [Breaking change] codegen-generated decoders always raise an error instead of causing the calling NIF to return an atom in some cases Fix codegen problem for untagged enums (#370) Fix handling local dependencies with @external_resources (#381)","ref":"changelog.html#0-22-1-2021-10-05","title":"Changelog - [0.22.1] - 2021-10-05","type":"extras"},{"doc":"Added Simple Debug impl for rustler::Error Support newtype and tuple structs for NifTuple and NifRecord rustler::Error::Term encoding an arbitrary boxed encoder, returning {:error, term} Generic encoder/decoder for HashMap&lt;T, U&gt; , where T: Decoder and U: Decoder Fixed Compilation time of generated decoders has been reduced significantly. Fixed a segfault caused by OwnedEnv::send_and_clear Changes Renamed Pid to LocalPid to clarify that it can't point to a remote process Dependencies have been updated. Derive macros have been refactored. Macros have been renamed and old ones have been deprecated: rustler_export_nifs! is now rustler::init! rustler_atoms! is now rustler::atoms! resource_struct_init! is now rustler::resource! New rustler::atoms! macro removed the atom prefix from the name: // // Before // rustler::rustler_atoms! { atom ok; atom error; atom renamed_atom = &quot;Renamed&quot;; } // // After // rustler::atoms! { ok, error, renamed_atom = &quot;Renamed&quot;, } NIF functions can be initialized with a simplified syntax: // // Before // rustler::rustler_export_nifs! { &quot;Elixir.Math&quot;, [ (&quot;add&quot;, 2, add) ], None } // // After // rustler::init!(&quot;Elixir.Math&quot;, [add]); NIFs can be derived from regular functions, if the arguments implement Decoder and the return type implements Encoder : // // Before // fn add&lt;'a&gt;(env: Env&lt;'a&gt;, args: &amp;[Term&lt;'a&gt;]) -&gt; Result&lt;Term&lt;'a&gt;, Error&gt; { let num1: i64 = args[0].decode()?; let num2: i64 = args[1].decode()?; Ok((atoms::ok(), num1 + num2).encode(env)) } // // After // #[rustler::nif] fn add(a: i64, b: i64) -&gt; i64 { a + b } rustler::nif exposes more options to configure a NIF were the NIF is defined: #[rustler::nif(schedule = &quot;DirtyCpu&quot;)] pub fn dirty_cpu() -&gt; Atom { let duration = Duration::from_millis(100); std::thread::sleep(duration); atoms::ok() } #[rustler::nif(name = &quot;my_add&quot;)] fn add(a: i64, b: i64) -&gt; i64 { a + b } Deprecations The rustler compiler has been deprecated and will be removed with v1.0. NIFs are no longer defined in mix.exs , but are configured with use Rustler . See the documentation for the Rustler module. To migrate to the new configuration: Drop :rustler from the :compilers key in your mix.exs project/0 function Drop :rustler_crates from project/0 and move the configurations into the use Rustler of your NIF module or application config: # config/dev.exs config :my_app , MyApp.Native , mode : :debug For more information, see the documentation .","ref":"changelog.html#0-22-0-2021-06-22","title":"Changelog - [0.22.0] - 2021-06-22","type":"extras"},{"doc":"Added Support for OTP22. Rust linting with clippy . Support for decoding IOLists as binaries, Term::decode_as_binary . Changes rustler_codegen is now reexported by the rustler crate. Depending on the rustler_codegen crate is deprecated. erlang_nif-sys has been renamed to rustler_sys and vendored into the rustler repo. Replaced the hand-rolled TOML parser in rustler_mix with the toml-elixir package. Improve error messages for derived encoders/decoders. Rust bool now corresponds only to booleans ( false , true ) in Elixir. Previously, nil and false were both decodable to bool . To use the previous behaviour, a Truthy newtype was introduced.","ref":"changelog.html#0-21-0-2019-09-07","title":"Changelog - [0.21.0] - 2019-09-07","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright [yyyy] [name of copyright owner] Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license-apache.html","title":"License (Apache-2.0)","type":"extras"},{"doc":"Copyright (c) 2016 hansihe Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license-mit.html","title":"License (MIT)","type":"extras"},{"doc":"The Mix package for rustler , a library to write Erlang Native Implemented Functions (NIFs) in Rust programming language.","ref":"readme.html","title":"Rustler","type":"extras"},{"doc":"This package is available on Hex.pm . To install it, add :rustler to your dependencies: def deps do [ { :rustler , &quot;~&gt; 0.29.0&quot; } ] end","ref":"readme.html#installation","title":"Rustler - Installation","type":"extras"},{"doc":"Fetch all necessary dependencies: $ mix deps.get Check your installation by showing help from the installed Mix task: $ mix help rustler.new Generate the boilerplate for a new Rustler project. Follow the instructions to configure your project: $ mix rustler.new Load the NIF in your program. .","ref":"readme.html#usage","title":"Rustler - Usage","type":"extras"},{"doc":"The Rust crate compilation can be controlled via Mix compile-time configuration in config/config.exs . See configuration options for more details.","ref":"readme.html#crate-configuration","title":"Rustler - Crate configuration","type":"extras"},{"doc":"Loading a Rustler NIF is done in almost the same way as normal NIFs. The actual loading is done by calling use Rustler, otp_app: :my_app in the module you want to load the NIF in. This sets up the @on_load module hook to load the NIF when the module is first loaded. defmodule MyProject.MyModule do use Rustler , otp_app : :my_app , crate : :my_crate # When loading a NIF module, dummy clauses for all NIF function are required. # NIF dummies usually just error out when called when the NIF is not loaded, as that should never normally happen. def my_native_function ( _arg1 , _arg2 ) , do : :erlang . nif_error ( :nif_not_loaded ) end Note that :crate is the name in the [lib] section of your Cargo.toml . The :crate option is optional if your crate and otp_app use the same name. See the Rustler module for more information.","ref":"readme.html#loading-the-nif","title":"Rustler - Loading the NIF","type":"extras"},{"doc":"Licensed under either of Apache License, Version 2.0, ( LICENSE-APACHE or http://www.apache.org/licenses/LICENSE-2.0 ) MIT license ( LICENSE-MIT or http://opensource.org/licenses/MIT ) at your option.","ref":"readme.html#copyright-and-license","title":"Rustler - Copyright and License","type":"extras"},{"doc":"Unless you explicitly state otherwise, any contribution intentionally submitted for inclusion in the work by you, as defined in the Apache-2.0 license, shall be dual licensed as above, without any additional terms or conditions.","ref":"readme.html#contribution","title":"Rustler - Contribution","type":"extras"}]